/*****************************************************
 *                                                    
 *    File Name : lu.c                                
 *                                                    
 *    Author    : KIM, DONGMIN (kimd@top.cis.syr.edu) 
 *                                                    
 *****************************************************/

#include <stdio.h>
#include <malloc.h>
#include <sys/types.h>
#include <unistd.h>
#include <math.h>
#include <string.h>

main(argc,argv)
     int  argc;
     char *argv[];
{
  int nsize;
  int inch1, outch1, outch2;
  char	**buf;
  char tmp[10];
  char *temp;
  int i, j, k;
  int matrix_size, type, size;
  int to, row, load, from;
  float **Matrix, **submatrix, **L, **U;
  float element, zero;
  char	*out1_msg;
  char	*out2_msg;

  long  total_elapsed;
  FILE  *fd, *fd1;
  char  *task_name;
  int   task_id;
  char  file_name[100];
  char  *io_file;
  int   *counter;
  char  *buf2;
  int   *tmp_matrix_size;
  int   total_size;
  char  *send_buf1;
  char  *send_buf2;

  char input_file[30];
  char output_L[30];
  char output_U[30];

  strcpy(input_file, argv[1]);
  strcpy(output_L, argv[2]);
  strcpy(output_U, argv[3]);

  /* external file */
  /* get input data from file */

  fd1 = fopen(input_file, "r");
 
  if ( fd1 == NULL ) {
    printf("\ncannot find file!\n");
    exit(1);
  }
 
  /* read the size of the matrix. */
  fscanf( fd1, "%d", &matrix_size );
  Matrix =  (float **) malloc(matrix_size * sizeof(float *));
  if (Matrix == NULL) {
    printf("malloc error at Matrix");
  }
  for ( i = 0 ; i < matrix_size ; i++ ) {
    Matrix[i] = (float *) malloc(matrix_size * sizeof(float));
    if (Matrix[i] == NULL) {
      printf("malloc error at Matrix[%d]", i);
    }
  }

  /* read from the file */
  for ( i = 0 ; i < matrix_size ; i++ ) {
    for ( j = 0 ; j < matrix_size ; j++ ) {
      fscanf(fd1, "%f", &element);
      Matrix[i][j] = element;
    }
  }
  fclose(fd1);

  sec_timer_reset();

  compute_lu(Matrix, matrix_size);


  total_elapsed = sec_timer_elapsed();
	
  printf("LU-decomposition - matrix size %d : %d\n", matrix_size, total_elapsed);

  /**
  L =  (float **) malloc(matrix_size * sizeof(float *));
  if (L == NULL) {
    printf("malloc error at L");
  }

  for ( i = 0 ; i < matrix_size ; i++ ) {
    L[i] = (float *) malloc(matrix_size * sizeof(float));
    if (L[i] == NULL) {
      printf("malloc error at L[%d]", i);
    }
  }

  U =  (float **) malloc(matrix_size * sizeof(float *));
  if (U == NULL) {
    printf("malloc error at U");
  }
  for ( i = 0 ; i < matrix_size ; i++ ) {
    U[i] = (float *) malloc(matrix_size * sizeof(float));
    if (U[i] == NULL) {
      printf("malloc error at U[%d]", i);
    }
  }

  for ( i = 0 ; i < matrix_size ; i++ ) {
    for ( j = 0 ; j < matrix_size ; j++ ) {
      if ( i > j ) {
	L[i][j] = Matrix[i][j];
	U[i][j] = 0.;
      }
      else if ( i < j ) {
	L[i][j] = 0.;
	U[i][j] = Matrix[i][j];
      }
      else {
	L[i][j] = 1.;
	U[i][j] = Matrix[i][j];
      }
    }
  }

  // external file
  fd1 = fopen(output_L, "w");
 
  if ( fd1 == NULL ) {
    printf("\ncannot find file!\n");
  }
  else {
    fprintf(fd1, "%d\n", matrix_size);
    for ( i = 0 ; i < matrix_size ; i++ ) {
      for ( j = 0 ; j < matrix_size ; j++ ) {
	fprintf( fd1, "%7.3f", L[i][j]);
      }
      fprintf(fd1, "\n");
    }
    fclose(fd1);
  }

  // external file
  fd1 = fopen(output_U, "w");
 
  if ( fd1 == NULL ) {
    fprintf(fd, "\ncannot find file!\n");
  }
  else {
    fprintf(fd1, "%d\n", matrix_size);
    for ( i = 0 ; i < matrix_size ; i++ ) {
      for ( j = 0 ; j < matrix_size ; j++ ) {
	fprintf( fd1, "%7.3f", U[i][j]);
      }
      fprintf(fd1, "\n");
    }
    fclose(fd1);
  }
  **/
}

compute_lu(Matrix, matrix_size)
float **Matrix;
int   matrix_size;
{

  int i, j, k;
  int current_id, current_row;
  int int_size, float_size, size;
  int current_slave;
  float Base, sum;
  
  /* k is the actual row number that is changed..
     current_slave is a slave number in which the row is changed.
     current_row is the row that is changed in each slave. */

  for ( j = 1 ; j < matrix_size ; j++ ) {
    Matrix[j][0] = Matrix[j][0] / Matrix[0][j];
  }

  for ( i = 1 ; i < matrix_size ; i++ ) {
    for ( k = 0 ; k < i - 1 ; k++ ) {
      Matrix[i][i] = Matrix[i][i] - Matrix[i][k] * Matrix[k][i];
    }

    for ( j = i + 1 ; j < matrix_size ; j++ ) {

      for ( k = 0 ; k < i - 1 ; k++ ) {
	Matrix[i][j] = Matrix[i][j] - Matrix[i][k] * Matrix[k][j];
      }

      for ( k = 0 ; k < i - 1 ; k++ ) {
	Matrix[j][i] = Matrix[j][i] - Matrix[j][k] * Matrix[k][i];
      }

      Matrix[j][i] = Matrix[j][i] / Matrix[i][i];
    }
  }
}


